diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.cpp
index bf4cacf..ee4831a 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.cpp
@@ -13,14 +13,12 @@ static const u8 nothing_id[]	= { 0x00, 0x00, 0x00, 0x00, 0x2e, 0x2e };
 // The id for a partially inserted extension
 static const u8 partially_id[]	= { 0x00, 0x00, 0x00, 0x00, 0xff, 0xff };
 
-Attachment::Attachment( const char* const _name, WiimoteEmu::ExtensionReg& _reg )
-	: name( _name ), reg( _reg )
+Attachment::Attachment( const char* const _name ) : name( _name )
 {
-	memset(id, 0, sizeof(id));
-	memset(calibration, 0, sizeof(calibration));
+	reg.resize( WIIMOTE_REG_EXT_SIZE, 0);
 }
 
-None::None( WiimoteEmu::ExtensionReg& _reg ) : Attachment( "None", _reg )
+None::None() : Attachment( "None" )
 {
 	// set up register
 	memcpy(&id, nothing_id, sizeof(nothing_id));
@@ -34,9 +32,8 @@ std::string Attachment::GetName() const
 void Attachment::Reset()
 {
 	// set up register
-	memset( &reg, 0, WIIMOTE_REG_EXT_SIZE );
-	memcpy( &reg.constant_id, id, sizeof(id) );
-	memcpy( &reg.calibration, calibration, sizeof(calibration) );
+	reg.clear();
+	reg.resize( WIIMOTE_REG_EXT_SIZE, 0);
 }
 
 }
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.h
index dfa292b..7eb937a 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Attachment.h
@@ -14,14 +14,14 @@ namespace WiimoteEmu
 class Attachment : public ControllerEmu
 {
 public:
-	Attachment( const char* const _name, WiimoteEmu::ExtensionReg& _reg );
+	Attachment( const char* const _name );
 
 	virtual void GetState( u8* const data, const bool focus = true ) {}
 	void Reset();
 	std::string GetName() const;
 
 	const char*	const			name;
-	WiimoteEmu::ExtensionReg&	reg;
+	std::vector<u8>             reg;
 
 	u8 id[6];
 	u8 calibration[0x10];
@@ -30,7 +30,7 @@ public:
 class None : public Attachment
 {
 public:
-	None( WiimoteEmu::ExtensionReg& _reg );
+	None();
 };
 
 }
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.cpp
index 5b0d962..4f92c36 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.cpp
@@ -50,10 +50,10 @@ static const char* const classic_trigger_names[] =
 
 static const u16 classic_dpad_bitmasks[] =
 {
-	Classic::PAD_UP, Classic::PAD_DOWN, Classic::PAD_LEFT, Classic::PAD_RIGHT 
+	Classic::PAD_UP, Classic::PAD_DOWN, Classic::PAD_LEFT, Classic::PAD_RIGHT
 };
 
-Classic::Classic(WiimoteEmu::ExtensionReg& _reg) : Attachment(_trans("Classic"), _reg)
+Classic::Classic() : Attachment(_trans("Classic"))
 {
 	// buttons
 	groups.push_back(m_buttons = new Buttons("Buttons"));
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.h
index ac68b2a..852eb74 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Classic.h
@@ -10,7 +10,7 @@ namespace WiimoteEmu
 class Classic : public Attachment
 {
 public:
-	Classic(WiimoteEmu::ExtensionReg& _reg);
+	Classic();
 	void GetState( u8* const data, const bool focus );
 
 	enum
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.cpp
index 1ae774b..2846fb6 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.cpp
@@ -32,7 +32,7 @@ static const u16 drum_button_bitmasks[] =
 	Drums::BUTTON_PLUS,
 };
 
-Drums::Drums(WiimoteEmu::ExtensionReg& _reg) : Attachment(_trans("Drums"), _reg)
+Drums::Drums() : Attachment(_trans("Drums"))
 {
 	// pads
 	groups.push_back(m_pads = new Buttons(_trans("Pads")));
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.h
index 3771140..fc0d485 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Drums.h
@@ -10,7 +10,7 @@ namespace WiimoteEmu
 class Drums : public Attachment
 {
 public:
-	Drums(WiimoteEmu::ExtensionReg& _reg);
+	Drums();
 	void GetState( u8* const data, const bool focus );
 
 	enum
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.cpp
index 23a2f93..8097c08 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.cpp
@@ -36,7 +36,7 @@ static const u16 guitar_strum_bitmasks[] =
 	Guitar::BAR_DOWN,
 };
 
-Guitar::Guitar(WiimoteEmu::ExtensionReg& _reg) : Attachment(_trans("Guitar"), _reg)
+Guitar::Guitar() : Attachment(_trans("Guitar"))
 {
 	// frets
 	groups.push_back(m_frets = new Buttons(_trans("Frets")));
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.h
index 245ebab..8d1e718 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Guitar.h
@@ -10,7 +10,7 @@ namespace WiimoteEmu
 class Guitar : public Attachment
 {
 public:
-	Guitar(WiimoteEmu::ExtensionReg& _reg);
+	Guitar();
 	void GetState( u8* const data, const bool focus );
 
 	enum
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.cpp
index 63dd485..5dbf285 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.cpp
@@ -10,29 +10,14 @@
 namespace WiimoteEmu
 {
 
-static const u8 nunchuck_id[] = { 0x00, 0x00, 0xa4, 0x20, 0x00, 0x00 };
-/* Default calibration for the nunchuck. It should be written to 0x20 - 0x3f of the
-   extension register. 0x80 is the neutral x and y accelerators and 0xb3 is the
-   neutral z accelerometer that is adjusted for gravity. */
-static const u8 nunchuck_calibration[] =
-{
-	0x80, 0x80, 0x80, 0x00, // accelerometer x, y, z neutral
-	0xb3, 0xb3, 0xb3, 0x00, //  x, y, z g-force values 
-
-	// 0x80 = analog stick x and y axis center
-	0xff, 0x00, 0x80,
-	0xff, 0x00, 0x80,
-	0xec, 0x41 // checksum on the last two bytes
-};
-
 static const u8 nunchuk_button_bitmasks[] =
 {
 	Nunchuk::BUTTON_C,
 	Nunchuk::BUTTON_Z,
 };
 
-Nunchuk::Nunchuk(UDPWrapper *wrp, WiimoteEmu::ExtensionReg& _reg)
-	: Attachment(_trans("Nunchuk"), _reg) , m_udpWrap(wrp)
+Nunchuk::Nunchuk(UDPWrapper *wrp)
+	: Attachment(_trans("Nunchuk")) , m_udpWrap(wrp)
 {
 	// buttons
 	groups.push_back(m_buttons = new Buttons("Buttons"));
@@ -49,7 +34,7 @@ Nunchuk::Nunchuk(UDPWrapper *wrp, WiimoteEmu::ExtensionReg& _reg)
 	groups.push_back(m_tilt = new Tilt("Tilt"));
 
 	// shake
-	groups.push_back(m_shake = new Buttons("Shake"));
+	groups.push_back(m_shake = new Buttons("Shake", true));
 	m_shake->controls.push_back(new ControlGroup::Input("X"));
 	m_shake->controls.push_back(new ControlGroup::Input("Y"));
 	m_shake->controls.push_back(new ControlGroup::Input("Z"));
@@ -66,98 +51,66 @@ Nunchuk::Nunchuk(UDPWrapper *wrp, WiimoteEmu::ExtensionReg& _reg)
 
 void Nunchuk::GetState(u8* const data, const bool focus)
 {
-	wm_extension* const ncdata = (wm_extension*)data;
-	ncdata->bt = 0;
-
-	// stick
-	ControlState state[2];
-	m_stick->GetState(&state[0], &state[1], 0, 1);
-
-	nu_cal &cal = *(nu_cal*)&reg.calibration;
-	nu_js cal_js[2];
-	cal_js[0] = *&cal.jx;
-	cal_js[1] = *&cal.jy;
-
-	for (int i = 0; i < 2; i++) {
-		ControlState &s = *&state[i];
-		nu_js c = *&cal_js[i];
-		if (s < 0)
-			s = s * abs(c.min - c.center) + c.center;
-		else if (s > 0)
-			s = s * abs(c.max - c.center) + c.center;
-		else
-			s = c.center;
-	}
-
-	ncdata->jx = u8(trim(state[0]));
-	ncdata->jy = u8(trim(state[1]));
-
-	if (ncdata->jx != cal.jx.center || ncdata->jy != cal.jy.center)
-	{
-		if (ncdata->jy == cal.jy.center)
-			ncdata->jy = cal.jy.center + 1;
-		if (ncdata->jx == cal.jx.center)
-			ncdata->jx = cal.jx.center + 1;
-	}
-
-	if (!focus)
-	{
-		ncdata->jx = cal.jx.center;
-		ncdata->jy = cal.jy.center;
-	}
-
-	AccelData accel;
-	accel_cal* calib = (accel_cal*)&reg.calibration[0];
-
-	// tilt
-	EmulateTilt(&accel, m_tilt, focus);
-
-	if (focus)
-	{
-		// swing
-		EmulateSwing(&accel, m_swing);
-		// shake
-		EmulateShake(&accel, calib, m_shake, m_shake_step);
-		// buttons
-		m_buttons->GetState(&ncdata->bt, nunchuk_button_bitmasks);
-	}
-	
-	// flip the button bits :/
-	ncdata->bt ^= 0x03;
-	
-	if (m_udpWrap->inst)
-	{
-		if (m_udpWrap->updNun)
-		{
-			u8 mask;
-			float x, y;
-			m_udpWrap->inst->getNunchuck(x, y, mask);
-			// buttons
-			if (mask & UDPWM_NC)
-				ncdata->bt &= ~WiimoteEmu::Nunchuk::BUTTON_C;
-			if (mask & UDPWM_NZ)
-				ncdata->bt &= ~WiimoteEmu::Nunchuk::BUTTON_Z;
-			// stick
-			if (ncdata->jx == 0x80 && ncdata->jy == 0x80)
-			{
-				ncdata->jx = u8(0x80 + x*127);
-				ncdata->jy = u8(0x80 + y*127);
-			}
-		}
-		if (m_udpWrap->updNunAccel)
-		{
-			float x, y, z;
-			m_udpWrap->inst->getNunchuckAccel(x, y, z);
-			accel.x = x;
-			accel.y = y;
-			accel.z = z;
-		}	
-	}
-
-	wm_accel* dt = (wm_accel*)&ncdata->ax;
-	dt->x = u8(trim(accel.x * (calib->one_g.x - calib->zero_g.x) + calib->zero_g.x));
-	dt->y = u8(trim(accel.y * (calib->one_g.y - calib->zero_g.y) + calib->zero_g.y));
-	dt->z = u8(trim(accel.z * (calib->one_g.z - calib->zero_g.z) + calib->zero_g.z));
+    wm_nc* const ncdata = (wm_nc*)data;
+    memset(&ncdata->bt, 0, sizeof(ncdata->bt));
+
+    // stick / not using calibration data for stick, o well
+    m_stick->GetState(&ncdata->jx, &ncdata->jy, 0x80, focus ? 127 : 0);
+
+    accel_cal* calib = (accel_cal*)&reg[0x20];
+
+    // tilt
+    EmulateTilt(&m_accel, m_tilt, focus);
+
+    if (focus)
+    {
+        // swing
+        EmulateSwing(&m_accel, m_swing);
+        // shake
+        EmulateShake(&m_accel, calib, m_shake, m_shake_step);
+        // buttons
+        m_buttons->GetState((u8*)&ncdata->bt, nunchuk_button_bitmasks);
+    }
+
+    // flip the button bits :/
+    *(u8*)&ncdata->bt ^= 0x03;
+
+    if (m_udpWrap->inst)
+    {
+        if (m_udpWrap->updNun)
+        {
+            u8 mask;
+            float x, y;
+            m_udpWrap->inst->getNunchuck(x, y, mask);
+            // buttons
+            if (mask & UDPWM_NC)
+                ncdata->bt.c = 0;
+            if (mask & UDPWM_NZ)
+                ncdata->bt.z = 0;
+            // stick
+            if (ncdata->jx == 0x80 && ncdata->jy == 0x80)
+            {
+                ncdata->jx = u8(0x80 + x*127);
+                ncdata->jy = u8(0x80 + y*127);
+            }
+        }
+        if (m_udpWrap->updNunAccel)
+        {
+            float x, y, z;
+            m_udpWrap->inst->getNunchuckAccel(x, y, z);
+            m_accel.x = x;
+            m_accel.y = y;
+            m_accel.z = z;
+        }
+    }
+
+    wm_accel* dt = (wm_accel*)&ncdata->ax;
+    //dt->x = u8(Common::trim8(m_accel.x * (calib->one_g.x - calib->zero_g.x) + calib->zero_g.x));
+    dt->x = u8(m_accel.x * (calib->one_g.x - calib->zero_g.x) + calib->zero_g.x <= 0 ? 0 : (m_accel.x * (calib->one_g.x - calib->zero_g.x) + calib->zero_g.x >= 0xff ? 0xff : m_accel.x * (calib->one_g.x - calib->zero_g.x) + calib->zero_g.x));
+    //dt->y = u8(Common::trim8(m_accel.y * (calib->one_g.y - calib->zero_g.y) + calib->zero_g.y));
+    dt->y = u8(m_accel.y * (calib->one_g.y - calib->zero_g.y) + calib->zero_g.y <= 0 ? 0 : (m_accel.y * (calib->one_g.y - calib->zero_g.y) + calib->zero_g.y >= 0xff ? 0xff : m_accel.y * (calib->one_g.y - calib->zero_g.y) + calib->zero_g.y));
+    //dt->z = u8(Common::trim8(m_accel.z * (calib->one_g.z - calib->zero_g.z) + calib->zero_g.z));
+    dt->z = u8(m_accel.z * (calib->one_g.z - calib->zero_g.z) + calib->zero_g.z <= 0 ? 0 : (m_accel.z * (calib->one_g.z - calib->zero_g.z) + calib->zero_g.z >= 0xff ? 0xff : m_accel.z * (calib->one_g.z - calib->zero_g.z) + calib->zero_g.z));
 }
 
 void Nunchuk::LoadDefaults(const ControllerInterface& ciface)
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.h
index 3b720f7..904ecab 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Nunchuk.h
@@ -12,10 +12,24 @@ class UDPWrapper;
 namespace WiimoteEmu
 {
 
+static const u8 nunchuck_id[] = { 0x00, 0x00, 0xa4, 0x20, 0x00, 0x00 };
+
+/* Default calibration for the nunchuck. It should be written to 0x20 - 0x3f of the
+   extension register. 0x80 is the neutral x and y accelerators and 0xb3 is the
+   neutral z accelerometer that is adjusted for gravity. */
+static const u8 nunchuck_calibration[] =
+{
+	0x80,0x80,0x80,0x00, // accelerometer x, y, z neutral
+	0x9a,0x9a,0x9a,0x00, //  x, y, z g-force values
+
+	0xff, 0x00, 0x80, 0xff, // 0xff max, 0x00 min, 0x80 = analog stick x and y axis center
+	0x00, 0x80, 0xa1, 0xf6	// checksum on the last two bytes
+};
+
 class Nunchuk : public Attachment
 {
 public:
-	Nunchuk(UDPWrapper * wrp, WiimoteEmu::ExtensionReg& _reg);
+	Nunchuk(UDPWrapper * wrp);
 
 	virtual void GetState( u8* const data, const bool focus );
 
@@ -27,6 +41,8 @@ public:
 
 	void LoadDefaults(const ControllerInterface& ciface);
 
+	AccelData		m_accel;
+
 private:
 	Tilt*			m_tilt;
 	Force*			m_swing;
@@ -37,7 +53,7 @@ private:
 	AnalogStick*	m_stick;
 
 	u8	m_shake_step[3];
-	
+
 	UDPWrapper* const m_udpWrap;
 };
 
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.cpp
index 901ad27..fe0c390 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.cpp
@@ -30,7 +30,7 @@ static const char* const turntable_button_names[] =
 	"-", "+", _trans("Euphoria"),
 };
 
-Turntable::Turntable(WiimoteEmu::ExtensionReg& _reg) : Attachment(_trans("Turntable"), _reg)
+Turntable::Turntable() : Attachment(_trans("Turntable"))
 {
 	// buttons
 	groups.push_back(m_buttons = new Buttons("Buttons"));
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.h b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.h
index b2c73e1..cc2a07f 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/Attachment/Turntable.h
@@ -10,7 +10,7 @@ namespace WiimoteEmu
 class Turntable : public Attachment
 {
 public:
-	Turntable(WiimoteEmu::ExtensionReg& _reg);
+	Turntable();
 	void GetState(u8* const data, const bool focus);
 
 	enum
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
index 235d5cb..4fe565f 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/EmuSubroutines.cpp
@@ -23,167 +23,351 @@
 #include "Common.h"
 #include "FileUtil.h"
 
+#include "../Wiimote.h"
 #include "WiimoteEmu.h"
 #include "WiimoteHid.h"
 #include "../WiimoteReal/WiimoteReal.h"
 
 #include "Attachment/Attachment.h"
+#include "Attachment/Nunchuk.h"
 
 namespace WiimoteEmu
 {
 
+Wiimote* spy_wm = 0;
+
+struct last_report_
+{
+	u8 type;
+	u8 data[MAX_PAYLOAD];
+};
+
 void Spy(Wiimote* wm_, const void* data_, int size_)
 {
 #if 0
+	if (size_ <= 0 || size_ > MAX_PAYLOAD)
+		return;
+
 	// enable log
-	bool logCom = true;
-	bool logData = true;
-	bool logMP = false;
-	bool logAudio = false;
+	bool log_com = true;
+	bool log_data = true;
+	bool log_mp = false;
+	bool log_audio = false;
 
-	std::string Name, TmpData;
-	static int c;
-	int size;
-	u16 SampleValue;
-	bool AudioData = false;
-	bool DataReport = false;
-	static std::queue<u32> dataRep;
-	static u8 dataReply[3] = {0};
-	bool emu = wm_;
-	static Wiimote* wm = 0;
+	// save data
+	bool save = false;
 
-	// a container for f.e. the extension encryption key
-	if (!wm_ && !wm)
-		wm = new Wiimote(0);
-	else
-		wm = wm_;
+	// use empty container or emulated Wiimote 0
+	bool empty_container = false;
 
-	// ignore emulated Wiimote data
-	if (emu) return;
+	static Wiimote* wm_emu;
 
-	const hid_packet* const hidp = (hid_packet*)data_;
-	const wm_report* const sr = (wm_report*)hidp->data;
+	if (!spy_wm)
+	{
+		wm_emu = 0;
+
+		if (empty_container)
+			spy_wm = new Wiimote(0);
+		else
+			if (wm_)
+				spy_wm = wm_;
+	}
+
+	if (!spy_wm)
+		return;
+
+	if (wm_)
+		wm_emu = wm_;
+
+	// short name
+	Wiimote* wm = &*spy_wm;
+
+	bool audio_data = false;
+	bool data_report = false;
+
+	bool emu = wm_;
+	string com = "", formatted = "";
+	static int c;
+	u8 report_mode = 0;
+	u16 reg_type = 0;
+	static wm_read_data g_rd;
+
+	// last report
+	static last_report_ last_report_emu;
+	static last_report_ last_report_real;
+	last_report_ &last_data = emu ? last_report_emu : last_report_real;
 
 	// use a non-pointer array because that makes read syntax shorter
-	u8 data[32] = {};
+	u8 data[MAX_PAYLOAD] = {};
 	memcpy(data, data_, size_);
 
-	switch(data[1])
+	const hid_packet* const hidp = (hid_packet*)data;
+	const wm_report* const sr = (wm_report*)hidp->data;
+
+	// ignore emulated Wiimote data
+	//if (emu) return;
+
+	if (g_wiimote_sources[0]
+		&& WIIMOTE_SRC_HYBRID == g_wiimote_sources[0]
+		&& !emu)
+		return;
+
+	// log controls
+	static bool key_down[0xff] = {false};
+	static int modify = 0;
+
+	if (!key_down[VK_PRIOR] && GetAsyncKeyState(VK_PRIOR))
+	{
+		log_data = !log_data; key_down[VK_PRIOR] = true;
+		WARN_LOG(CONSOLE, "log_data: %d", log_data);
+	}
+	if (!GetAsyncKeyState(VK_PRIOR)) key_down[VK_PRIOR] = false;
+
+	if (!key_down[VK_NEXT] && GetAsyncKeyState(VK_NEXT))
+	{
+		log_mp = !log_mp;
+		key_down[VK_NEXT] = true;
+		WARN_LOG(CONSOLE, "log_mp: %d", log_mp);
+	}
+	if (!GetAsyncKeyState(VK_NEXT)) key_down[VK_NEXT] = false;
+
+	if (!key_down[VK_INSERT] && GetAsyncKeyState(VK_INSERT))
+	{
+		modify++;
+		if (modify > 2)
+			modify = 0;
+		key_down[VK_INSERT] = true;
+		WARN_LOG(CONSOLE, "Modify: %d", modify);
+	}
+	if (!GetAsyncKeyState(VK_INSERT)) key_down[VK_INSERT] = false;
+
+	if (!key_down[VK_HOME] && GetAsyncKeyState(VK_HOME))
+	{
+		wm->m_options->settings[3]->value = !wm->GetMotionPlusAttached();
+		key_down[VK_HOME] = true;
+		WARN_LOG(CONSOLE, "M+: %f", wm->m_options->settings[3]->value);
+	}
+	if (!GetAsyncKeyState(VK_HOME)) key_down[VK_HOME] = false;
+
+
+	if (!key_down[VK_END] && GetAsyncKeyState(VK_END))
+	{
+		wm->m_extension->switch_extension = wm->m_extension->active_extension != 1 ? 1 : 0; key_down[VK_END] = true;
+		WARN_LOG(CONSOLE, "NC: %d (%d)", wm->m_extension->switch_extension, wm->m_extension->active_extension);
+	}
+	if(!GetAsyncKeyState(VK_END)) key_down[VK_END] = false;
+
+	if(!key_down[VK_DELETE] && GetAsyncKeyState(VK_DELETE)) {
+		wm->m_options->settings[SETTING_IR_HIDE]->value = wm->m_options->settings[SETTING_IR_HIDE]->value != 1 ? 1 : 0;
+		key_down[VK_DELETE] = true;
+		WARN_LOG(CONSOLE, "IR: %d", wm->m_options->settings[SETTING_IR_HIDE]->value);
+	}
+	if(!GetAsyncKeyState(VK_DELETE)) key_down[VK_DELETE] = false;
+
+	//WARN_LOG_S(CONSOLE, "Data: %s", ArrayToString((const u8*)data_, Size, 0, 30).c_str());
+
+
+	// print data
+	//DEBUG_LOG(CONSOLE, "DATA: %s", ArrayToString((u8*)data_, Size, 0, 30).c_str());
+	//DEBUG_LOG(CONSOLE, "E: %s", ArrayToString(((u8*)&wm->m_reg_ext), sizeof(tmp), 0, 30).c_str());
+	//DEBUG_LOG(CONSOLE, "+: %s", ArrayToString(((u8*)&wm->m_reg_motion_plus)[0xfa], 6, 0, 30).c_str());
+	//DEBUG_LOG(CONSOLE, "+: %s", ArrayToString(((u8*)&wm->m_reg_motion_plus), sizeof(wm->m_reg_motion_plus), 0, 30).c_str());
+	//DEBUG_LOG(CONSOLE, "E: %s", ArrayToString(((u8*)&wm->m_reg_ext.constant_id), sizeof(wm->m_reg_ext.constant_id)).c_str());
+	//DEBUG_LOG(CONSOLE, "+: %s", ArrayToString(((u8*)&wm->m_reg_motion_plus.ext_identifier), sizeof(wm->m_reg_motion_plus.ext_identifier)).c_str());
+
+	// modify report
+	if (modify)
+	{
+		if (sr->wm >= WM_REPORT_CORE && sr->wm <= WM_REPORT_CORE_ACCEL_IR10_EXT6)
+		{
+			if (sr->wm == WM_REPORT_CORE_ACCEL_IR10_EXT6 && ((wm_motionplus*)&sr->data[15])->is_mp_data)
+			{
+				//ERROR_LOG_S(CONSOLE, "1 | %s", ArrayToString(sr->data, size).c_str());
+				accel_cal* calib = (accel_cal*)&wm->m_eeprom[0x16];
+
+				if (modify == 1)
+				{
+					((wm_accel*)&sr->data[2])->x = calib->zero_g.x; ((wm_core*)&sr->data[0])->xL = calib->zero_g.xL;
+					((wm_accel*)&sr->data[2])->y = calib->zero_g.y; ((wm_core*)&sr->data[0])->yL = calib->zero_g.yL;
+					((wm_accel*)&sr->data[2])->z = calib->one_g.z; ((wm_core*)&sr->data[0])->zL = calib->one_g.zL;
+				}
+				if (modify == 2)
+				{
+					((wm_motionplus*)&sr->data[15])->yaw2 = 0x1f; ((wm_motionplus*)&sr->data[15])->yaw1 = 0x7f;
+					((wm_motionplus*)&sr->data[15])->roll2 = 0x1f; ((wm_motionplus*)&sr->data[15])->roll1 = 0x7f;
+					((wm_motionplus*)&sr->data[15])->pitch2 = 0x1f; ((wm_motionplus*)&sr->data[15])->pitch1 = 0x7f;
+				}
+				//ERROR_LOG_S(CONSOLE, "2 | %s", ArrayToString(sr->data, size).c_str());
+			}
+		}
+	}
+
+	switch(sr->wm)
 	{
 	case WM_RUMBLE:
-		size = 1;
-		if (logCom) Name.append("WM_RUMBLE");
+		if (log_com) com.append("WM_RUMBLE");
 		break;
 
 	case WM_LEDS:
-		size = sizeof(wm_leds);
-		if (logCom) Name.append("WM_LEDS");
+		if (log_com) com.append("WM_LEDS");
 		break;
 
 	case WM_REPORT_MODE:
-		size = sizeof(wm_report_mode);
-		if (logCom) Name.append("WM_REPORT_MODE");
-		ERROR_LOG(CONSOLE, "WM_REPORT_MODE: 0x%02x", data[3]);
+		if (log_com)
+		{
+			com.append("WM_REPORT_MODE");
+			formatted = StringFromFormat("mode: 0x%02x", data[3]);
+		}
+		wm->m_reporting_mode = data[3];
 		break;
 
 	case WM_IR_PIXEL_CLOCK:
-		if (logCom) Name.append("WM_IR_PIXEL_CLOCK");
+		if (log_com) com.append("WM_IR_PIXEL_CLOCK");
 		break;
 
 	case WM_SPEAKER_ENABLE:
-		if (logCom) Name.append("WM_SPEAKER_ENABLE");
-		NOTICE_LOG(CONSOLE, "Speaker on: %d", sr->enable);
+		if (log_com)
+		{
+			com.append("WM_SPEAKER_ENABLE");
+			formatted = StringFromFormat("on: %d", sr->enable);
+		}
 		break;
 
 	case WM_REQUEST_STATUS:
-		size = sizeof(wm_request_status);
-		if (logCom) Name.append("WM_REQUEST_STATUS");
-		NOTICE_LOG(CONSOLE, "WM_REQUEST_STATUS: %s", ArrayToString(data, size+2, 0).c_str());
+	{
+		wm_request_status* status = (wm_request_status*)sr->data;
+		if (log_com)
+		{
+			com.append("WM_REQUEST_STATUS");
+			formatted.append(StringFromFormat("rumble %d", status->rumble));
+		}
 		break;
+	}
 
 	case WM_WRITE_DATA:
 	{
-		if (logCom) Name.append("W 0x16");
-		size = sizeof(wm_write_data);
-
 		wm_write_data* wd = (wm_write_data*)sr->data;
+		//memcpy(wd, &data[7], 0x10);
 		u32 address = Common::swap24(wd->address);
 		address &= ~0x010000;
+		reg_type;
+
+		if (log_com)
+		{
+			com.append("WRITE");
+			formatted.append(StringFromFormat("%02x %08x %02x: %s\n", wd->space, address, wd->size, ArrayToString(wd->data, wd->size, 0).c_str()));
+		}
 
-		switch(data[2] >> 0x01)
+		switch(wd->space)
 		{
 		case WM_SPACE_EEPROM:
-			if (logCom) Name.append(" REG_EEPROM"); break;
-		case WM_SPACE_REGS1:
-		case WM_SPACE_REGS2: {
+			if (log_com) com.append(" REG_EEPROM");
+			if (save)
+				memcpy(wm->m_eeprom + address, wd->data, wd->size);
+			break;
 
+		case WM_SPACE_REGS1:
+		case WM_SPACE_REGS2:
+		{
+			// reg
+			reg_type = address >> 16;
 			const u8 region_offset = (u8)address;
 			void *region_ptr = NULL;
 			int region_size = 0;
 
-			switch(data[3])
+			switch(reg_type)
+			{
+			case WIIMOTE_REG_SPEAKER :
+				if (log_com) com.append(" REG_SPEAKER");
+				region_ptr = &wm->m_reg_speaker;
+				region_size = WIIMOTE_REG_SPEAKER_SIZE;
+				break;
+
+			case WIIMOTE_REG_EXT:
+				if (log_com) com.append(" REG_EXT");
+				region_ptr = wm->GetMotionPlusActive() ? (void*)&wm->m_reg_motion_plus : (void*)&wm->m_reg_ext;
+				region_size = WIIMOTE_REG_EXT_SIZE;
+				break;
+
+			case WIIMOTE_REG_MP :
+				if (log_com) com.append(" REG_M+");
+				if (!wm->GetMotionPlusActive())
+				{
+					region_ptr = &wm->m_reg_motion_plus;
+					region_size = WIIMOTE_REG_EXT_SIZE;
+				}
+				break;
+
+			case WIIMOTE_REG_IR:
+				 if (log_com) com.append(" REG_IR");
+				region_ptr = &wm->m_reg_ir;
+				region_size = WIIMOTE_REG_IR_SIZE;
+				 break;
+			}
+
+			// save register
+			if (save && region_ptr && (region_offset + wd->size <= region_size))
+				memcpy((u8*)region_ptr + region_offset, wd->data, wd->size);
+
+			// save key
+			if (save && region_ptr == &wm->m_reg_ext && address >= 0xa40040 && address <= 0xa4004c)
+			{
+				wiimote_gen_key(&wm->m_ext_key, wm->m_reg_ext.encryption_key);
+				formatted.append(StringFromFormat("writing key: %s", ArrayToString((u8*)&wm->m_ext_key, sizeof(wm->m_ext_key), 0, 30).c_str()));
+			}
+
+			switch(wd->space)
+			{
+			case WM_SPACE_REGS1:
+			case WM_SPACE_REGS2:
+			{
+			switch(reg_type)
 			{
-			case 0xa2:
-				if (logCom)
+			case WIIMOTE_REG_SPEAKER:
+				if (log_com)
 				{
-					Name.append(" REG_SPEAKER");
-					if(data[6] == 7)
+					com.append(" REG_SPEAKER");
+					if(wd->data[0] == 7)
 					{
-						//INFO_LOG(CONSOLE, "Sound configuration:");
-						if(data[8] == 0x00)
+						u16 sampleValue;
+
+						formatted.append("Sound configuration\n");
+						if (wd->data[2] == 0x00)
 						{
-							//memcpy(&SampleValue, &data[9], 2);
-							//NOTICE_LOG(CONSOLE, "    Data format: 4-bit ADPCM (%i Hz)", 6000000 / SampleValue);
-							//NOTICE_LOG(CONSOLE, "    Volume: %02i%%", (data[11] / 0x40) * 100);
+							memcpy(&sampleValue, &data[9], 2);
+							formatted.append(StringFromFormat(
+								"    format: 4-bit ADPCM (%i Hz)"
+								"    volume: %02i%%"
+
+								, 6000000 / sampleValue
+								, (data[11] / 0x40) * 100
+								));
 						}
-						else if (data[8] == 0x40)
+						else if (wd->data[2] == 0x40)
 						{
-							//memcpy(&SampleValue, &data[9], 2);
-							//NOTICE_LOG(CONSOLE, "    Data format: 8-bit PCM (%i Hz)", 12000000 / SampleValue);
-							//NOTICE_LOG(CONSOLE, "    Volume: %02i%%", (data[11] / 0xff) * 100);
+							memcpy(&sampleValue, &data[9], 2);
+							formatted.append(StringFromFormat(
+							"    format: 8-bit PCM (%i Hz)"
+							"    volume: %02i%%"
+
+							, 12000000 / sampleValue
+							, (data[11] / 0xff) * 100
+							));
 						}
 					}
 				}
 				break;
-			case 0xa4:
-				if (logCom) Name.append(" REG_EXT");
-				// Update the encryption mode
-				if (data[5] == 0xf0) {
-					if (!emu)
-						wm->m_reg_ext.encryption = wd->data[0];
-					//NOTICE_LOG(CONSOLE, "Extension encryption: %u", wm->m_reg_ext.encryption);
-				}
-				region_ptr = &wm->m_reg_ext;
-				break;
-			case 0xa6 :
-				if (logCom) Name.append(" REG_M+");
-				// update the encryption mode
-				if (data[5] == 0xf0) {
-					if (!emu)
-						wm->m_reg_motion_plus.activated = wd->data[0];
-					//NOTICE_LOG(CONSOLE, "Extension enryption: %u", wm->m_reg_ext.encryption);
-				}
-				region_ptr = &wm->m_reg_motion_plus;
+
+				case WIIMOTE_REG_EXT:
+				case WIIMOTE_REG_MP :
+					if (data[5] == 0xf0)
+						formatted.append(StringFromFormat("extension encryption: %02x", wm->m_reg_ext.encryption));
+					break;
+
 				break;
-			case 0xb0:
-				 if (logCom) Name.append(" REG_IR"); break;
 			}
-
-			// save register
-			if (!emu && region_ptr)
-				memcpy((u8*)region_ptr + region_offset, wd->data, wd->size);
-			// save key
-			if (region_offset >= 0x40 && region_offset <= 0x4c) {
-				if(!emu)
-					wiimote_gen_key(&wm->m_ext_key, wm->m_reg_ext.encryption_key);
-				INFO_LOG(CONSOLE, "Writing key: %s", ArrayToString((u8*)&wm->m_ext_key, sizeof(wm->m_ext_key), 0, 30).c_str());
 			}
-			if (data[3] == 0xa4 || data[3] == 0xa6) {
-				//DEBUG_LOG(CONSOLE, "M+: %s", ArrayToString((u8*)&wm->m_reg_motion_plus, sizeof(wm->m_reg_motion_plus), 0, 30).c_str());
-				//DEBUG_LOG(CONSOLE, "M+: %s", ArrayToString((u8*)&wm->m_reg_motion_plus.ext_identifier, sizeof(wm->m_reg_motion_plus.ext_identifier), 0, 30).c_str());
-				NOTICE_LOG(CONSOLE, "W[0x%02x 0x%02x|%d]: %s", data[3], region_offset,  wd->size, ArrayToString(wd->data, wd->size, 0).c_str());
 			}
-			break;
 		}
 		}
 
